LibreOffice LibreOffice 25.2 SDK API Reference

Exported Interfaces | List of all members
ExtendedTypeDetectionFactory Service Referencepublished

factory to create extended type detection components. More...

`import"ExtendedTypeDetectionFactory.idl";`

Inheritance diagram for ExtendedTypeDetectionFactory:

## Exported Interfaces
interface | com::sun::star::lang::XMultiServiceFactory
| factory interface to create and initialize extended type detection components. More...
interface | com::sun::star::container::XNameAccess
| provides read access to the complete set of configuration data. More...
interface | com::sun::star::container::XNameContainer
| provides a write access to the configuration data. More...
interface | com::sun::star::container::XContainerQuery
| provides search on the configuration data set. More...
interface | com::sun::star::util::XFlushable
| can be used to perform container changes. More...

## Additional Inherited Members
Public Member Functions inherited from XMultiServiceFactory
com::sun::star::uno::XInterface | createInstance ([in] string aServiceSpecifier) raises ( com::sun::star::uno::Exception )
| Creates an instance classified by the specified name. More...
com::sun::star::uno::XInterface | createInstanceWithArguments ([in] string ServiceSpecifier, [in] sequence< any > Arguments) raises ( com::sun::star::uno::Exception )
| Creates an instance classified by the specified name and passes the arguments to that instance. More...
sequence< string > | getAvailableServiceNames ()
| Provides the available names of the factory to be used to create instances. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XNameAccess
any | getByName ([in] string aName) raises ( com::sun::star::container::NoSuchElementException, com::sun::star::lang::WrappedTargetException )
sequence< string > | getElementNames ()
boolean | hasByName ([in] string aName)
Public Member Functions inherited from XElementAccess
type | getElementType ()
boolean | hasElements ()
Protected Member Functions inherited from XNameContainer
void | insertByName ([in] string aName, [in] any aElement) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::container::ElementExistException, com::sun::star::lang::WrappedTargetException )
| inserts the given element at the specified name. More...
void | removeByName ([in] string Name) raises ( com::sun::star::container::NoSuchElementException, com::sun::star::lang::WrappedTargetException )
| removes the element with the specified name. More...
Protected Member Functions inherited from XNameReplace
void | replaceByName ([in] string aName, [in] any aElement) raises ( com::sun::star::lang::IllegalArgumentException, com::sun::star::container::NoSuchElementException, com::sun::star::lang::WrappedTargetException )
| replaces the element with the specified name with the given element. More...
Protected Member Functions inherited from XContainerQuery
XEnumeration | createSubSetEnumerationByQuery ([in] string Query)
| creates a sub set of container items which match given query command More...
XEnumeration | createSubSetEnumerationByProperties ([in] sequence< com::sun::star::beans::NamedValue > Properties)
| creates a sub set of container items which supports searched properties as minimum More...
Protected Member Functions inherited from XFlushable
void | flush ()
| flushes the data of the object to the connected data source. More...
void | addFlushListener ([in] com::sun::star::util::XFlushListener l)
| adds the specified listener to receive event "flushed." More...
void | removeFlushListener ([in] com::sun::star::util::XFlushListener l)
| removes the specified listener. More...

## Detailed Description

factory to create extended type detection components.

This factory implements read/write access on the underlying configuration set. and further a validate and flush mechanism for more performance and a special query mode can be used here too.

Since
  OOo 1.1.2

## Exported Interfaces

## ◆ com::sun::star::container::XContainerQuery

interface com::sun::star::container::XContainerQuery
| optional

provides search on the configuration data set.

Against simple property search it provides some complex algorithms too. For further information please read the SDK documentation.

## ◆ com::sun::star::container::XNameAccess

interface com::sun::star::container::XNameAccess

provides read access to the complete set of configuration data.

Every container item is specified as a set of properties and will be represented by a sequence< com::sun::star::beans::PropertyValue > structure. Follow properties are supported: (But note: not all of them must be present every time!)

Property Name | Value Type | Description
Name | [string] | It means the UNO implementation name of the detector component. Note: It means the really the implementation instead of the UNO service name. Because it's not possible to distinguish between more than one components; if all of them uses a generic service identifier!
Types | [sequence< string >] | It's a list of all types, which can be detected by this extended detection component. All items of this list must match an item of the TypeDetection container service.

## ◆ com::sun::star::container::XNameContainer

interface com::sun::star::container::XNameContainer
| optional

provides a write access to the configuration data.

## ◆ com::sun::star::lang::XMultiServiceFactory

interface com::sun::star::lang::XMultiServiceFactory

factory interface to create and initialize extended type detection components.

A detection component must be specified by its UNO implementation name and will be created then. Every new created component can be initialized with its own configuration data and may given optional arguments of the corresponding createInstanceWithArguments() request. To do so the service must support the optional interface com::sun::star::lang::XInitialization. The arguments parameter will have the following structure:

- sequence< Any >[0] contains a sequence< com::sun::star::beans::PropertyValue >, which represent the configuration data set of this detector component. The used properties are the same, as they are available at the container interface of this factory service. (see below)
- Every following item of the argument list sequence< Any >[1..n] contains the copied argument of the corresponding createInstanceWithArguments() call. That means: Item 0 or the original list was copied as item 1 of the destination list ... etc.

## ◆ com::sun::star::util::XFlushable

interface com::sun::star::util::XFlushable
| optional

can be used to perform container changes.

Because the complexness of such configuration set can be very high, it seems not very useful to update the underlying configuration layer on every container change request immediately. Another strategy can be to make all changes (adding/changing/removing of items) and call flush at the end. That will validate the whole container and reject inconsistent data sets. Only in case all made changes was correct, they will be written back to the configuration. Further this interface provides the possibility, that interested changes listener can be registered too.

The documentation for this service was generated from the following file:

- com/sun/star/document/ExtendedTypeDetectionFactory.idl